# 0.0.6 (September 7, 2018)

* Fill node_to_bootstrap of friend with close nodes (#212)
* Parse packet type FriendRequests (#211)
* Add parameter for eviction strategy (#210)
* Speed up 'cargo test' for tcp (#209)
* Simplify constructor of Kbucket (#207)
* Refactor SockAndTime struct (#206)
* Parse packet type ShareRelays (#205)
* Add fake friends to DHT (#204)
* Handle all connections in ServerExt::run (#203)
* Renaming and minor refactoring (#202)
* Parse packet type Alive (#201, #208)
* Treat IPv4 and IPv6 addresses of same node as they belonged to different nodes (#200)
* Fix Appveyor to download libsodium v1.0.16 (#198)
* Remove pub from DHT Server::try_add_close_nodes (#197)
* Remove take_while while bootstrapping from nodes (#196)
* Avoid issues with floating point arithmetic (#195)
* Fix log for TCP server (#194)
* Bootstrap from bootstrap nodes when all nodes in Kbucket are discarded (#192)
* Limit bootstrap nodes of friend instead of close nodes (#191)
* Use cargo-clippy instead of deprecated clippy plugin (#189)
* Fix clippy warnings (#188, #190)
* Fix add overflow in DHT server (#187)
* Get closest global IP in OnionAnnounce (#187)
* Improve DHT tests (#186)
* Relicense to MIT/GPLv3+ (#185)
* Fix hole punching (#183, #193)
* Simplify example and synchronize it with tox-node (#182)
* Use DhtNode instead of PackedNode (#181)
* Update the status of the project (#180)
* Send periodic pings in TCP server (#178)
* Fix binary search in Kbucket (#177)
* Add crypto_core::random_usize (#176)
* Add mutable iterator for Kbucket (#175)
* DHT refactoring, NAT fixes, improve ping sender (#174, #179, #193)
* Set onion sink for DHT Server via setter (#173)
* Poll Future in PingSender::try_add (#172)
* Fix IPv6 in DHT (#171)
* Add TCP:ServerExt to serve each TCP connection (#170)
* Do not send LAN IPs in NodesResponse (#168)
* Optional LanDiscovery for DhtNode (#167)

# 0.0.5 (June 27, 2018)

* DHT refactoring, move periodic tasks from example into lib code (#161)
* Update the deps of the project (#159)
* Refactor old state_format, save/load DHT state from raw bytes (#158)
* Setup code coverage for gitlab CI (#157)
* Do not fall on invalid DHT packets (#156)
* Update minimal rustc version to 1.25 (#155)
* Migrate to cloc from tokio_timer (#154)
* Add Ping iterator (#151)
* Implement CryptoData handling (#150)
* Separate ClientData from DhtNode (#147)
* Implement CI on Travis for OsX (#145)
* Add Good and Bad status of a dht node (#144)
* Use correct IPv6 broadcast address (#143)
* Unify send functions, do not layer errors, set tcp onion sink in separate method (#143)
* Implement Net crypto handshake (#142)
* Update the status of the project (#140, #148)
* Fix the mechanism of verification commit messages in gitlab (#139)
* Add BootstrapInfo handler (#138)
* Fix type of DHT handle_packet function (#136)
* Prettify code a little bit in DHT module (#133)
* Implement Hole Punching and NatPing (#132)
* Add parsing for net crypto packets: CookieResponse, CryptoHandshake and CryptoData (#131)
* Add sha512 to cryptocore, refactor crypto core a little bit (#130)
* Implemented CI for gitlab for Linux and Windows (#129)
* Use constant keypair in example dht node (#128)
* Fix length of payloads in docs (#126, #127)
* Fix serialization of NodesResponsePayload (#126)
* Add DhtPkAnnounce payload to DhtRequest packet (#125)
* Add "onion" prefix to announce request/response (#123)
* Use crate `hex` instead of deprecated `rustc-serialize` (#122)
* Add IpPort::protocol to onion::IpPort (#119)
* Update minimal version of Rust to 1.24.0 (#118)
* Add full NodesRequest example (#117)
* Handle DHT onion packets that should be redirected to TCP (#116)
* Fix OnionRequest and OnionResponse packets in TCP module (#115)
* Update the version of `cookie-factory` (#114)
* Add sender's address to onion sink (#113)
* Move to our IoFuture since it is going to be deprecated in tokio (#112)

# 0.0.4 (April 27, 2018)

* Implement OnionAnnounce struct (#77)
* Use InnerOnionResponse as onion response payload (#85)
* Handle onion request/response packets in DHT Node (#88)
* Handle OnionAnnounceRequest/OnionDataRequest packets (#106)
* Add sender's address to TCP's onion sink (#113)
* Update TCP onion packets (#115)
* Migrate to parking_lot::RwLock instead of std (#82)
* Refactor DHT Node, remove client struct (#96)
* Fix "Decrypting DhtRequest failed" (#102)
* Add TCP Relay client connection (#10)
* Improve TCP Relay tests (#103)
* Add hash of pings to DHT server (#98)
* Fix ".ping_id does not match" (#86, #87)
* Migrate to tokio-timer v0.2 (#108)
* Remove timedout clients from DHT Node (#73)
* Remove useless union value from decryption errors (#110)
* Implement Lan Discovery handler (#71, #78)
* Split Onion, TCP, DHT Packet into multiple files (#72, #83, #109)
* Move to our IoFuture since it is going to be deprecated in tokio (#112)

# 0.0.3 (March 27, 2018)

* Parse all Onion packets (#50)
* Update Onion docs (#46)
* Enable OsX builds in CI (#62)
* Multithreaded TCP Relay (#58)
* Multithreaded DHT Node (#65)
* Update DHT Codec (#48)
* Fix clippy warnings (#63, #64)

# 0.0.2 (March 7, 2018)

* Parse TCP all packets
* Parse DHT Ping/Nat/NodesRequest/NodeResponse packets
* Parse Onion Request/Response packets
* Add example for TCP Relay
* Add example for DHT Node

# 0.0.1 (December 31, 2014)

* Squatter release (we did not make it)
